@version 2.0
@warnings
@script motion
/*
Written by faulknermano, Lernwel D Ang.
This LScript is offered uncompiled and may be modified for your learning experience.
*/

// follows pos and rot of tarobj on a range of kf's
// additive?
// use null as replacement for actual child obj to set
// proper rots and pos changes. have constrained follow that
// null.
// try multi ranges of kf's
// save info in scene file

// script is applied to the item to be constrained
// script will query for kf range
// script will check if current keyframe is within range
// script will apply or not apply pos and rot based on range
// script will support fixed number of ranges which is 3
// script can monitor three constraints

var first1 = 0;
var first2 = 60;
var first3 = 120;
var last1 = 59;
var last2 = 119;
var last3 = 179;
var p1;
var p2;
var p3;
var p1Name;
var p2Name;
var p3Name;
var fps;
var scene;

create
{
	info("create");
	setdesc("Time-Constrain Items");
	scene = getfirstitem(SCENE);
	fps = scene.fps;
}

process: ma, frame, time
{
	if(p1)
	{
		if(range(frame,first1,last1))
		{
			p1pos = p1.getWorldPosition(time);
			p1rot = p1.getRotation(time);
			ma.set(POSITION,p1pos);
			ma.set(ROTATION,p1rot);
		}
	}
	if(p2 && !range(frame,first1,last1))
	{
		if(range(frame,first2,last2))
		{
			p2pos = p2.getWorldPosition(time);
			p2rot = p2.getRotation(time);
			ma.set(POSITION,p2pos);
			ma.set(ROTATION,p2rot);
		}
	}
	if(p3 && !range(frame,first2,last2))
	{
		if(range(frame,first3,last3))
		{
			p3pos = p3.getWorldPosition(time);
			p3rot = p3.getRotation(time);
			ma.set(POSITION,p3pos);
			ma.set(ROTATION,p3rot);
		}
	}
}




options
{

	p1 = getfirstitem(p1Name) if(p1Name != nil);
	p2 = getfirstitem(p2Name) if(p2Name != nil);
	p3 = getfirstitem(p3Name) if(p3Name != nil);

	return if(!reqbegin("Constrain Items"));
	reqsize(230,200);

	a1 = ctlallitems("Parent 1",p1);
	ctlposition(a1,3,4);
	b1 = ctlinteger("First",first1);
	ctlposition(b1,10,29);
	c1 = ctlinteger("Last",last1);
	ctlposition(c1,107,29);

	a2 = ctlallitems("Parent 2",p2);
	ctlposition(a2,3,58);
	b2 = ctlinteger("First",first2);
	ctlposition(b2,10,83);
	c2 = ctlinteger("Last",last2);
	ctlposition(c2,107,83);

	a3 = ctlallitems("Parent 3",p3);
	ctlposition(a3,3,112);
	b3 = ctlinteger("First",first3);
	ctlposition(b3,10,137);
	c3 = ctlinteger("Last",last3);
	ctlposition(c3,107,137);

	return if(!reqpost());

	p1 = getvalue(a1);
	p2 = getvalue(a2);
	p3 = getvalue(a3);
	first1 = getvalue(b1);
	first2 = getvalue(b2);
	first3 = getvalue(b3);
	last1 = getvalue(c1);
	last2 = getvalue(c2);
	last3 = getvalue(c3);

	reqend();
	if(p1)
		p1Name = p1.name;
	if(p2)
		p2Name = p2.name;
	if(p3)
		p3Name = p3.name;

	if(p1 && p1Name == p2Name)
	{
		warn("Have same parents. Deselecting.");
		p2 = nil;
	}
	if(p1 && p1Name == p3Name)
	{
		warn("Have same parents. Deselecting.");
		p3 = nil;
	}
	if(p2 && p2Name == p3Name)
	{
		warn("Have same parents. Deselecting.");
		p3 = nil;
	}
}

save: what, io
{
	if(what == SCENEMODE)
	{
		p1Name = "nil" if(p1Name == nil);
		p2Name = "nil" if(p2Name == nil);
		p3Name = "nil" if(p3Name == nil);
		io.writeln("P1","|",p1Name,"|",first1,"|",last1);
		io.writeln("P2","|",p2Name,"|",first2,"|",last2);
		io.writeln("P3","|",p3Name,"|",first3,"|",last3);
	}
}

load: what, io
{
	info("load");
	if(what == SCENEMODE)
	{
		for(i=1;i<3;++i)
		{
			line = io.read();
			items = parse("|",line);
			if(items[1] == "P1")
			{
				p1Name = string(items[2]);
				first1 = integer(items[3]);
				last1 = integer(items[4]);
			}
			if(items[1] == "P2")
			{
				p2Name = string(items[2]);
				first2 = integer(items[3]);
				last2 = integer(items[4]);
			}
			if(items[1] == "P3")
			{
				p3Name = string(items[2]);
				first3 = integer(items[3]);
				last3 = integer(items[4]);
			}
		}

	}
}
